PRO ReadICON,file, num, dumdata,height,NumProfile
;filenameB='C:\Users\TITUS\Documents\Projects\ICON\ICON_L2-3_MIGHTI-B_Temperature_2020-06-26_v03r000.nc'

Fid=ncdf_open(file)
NCDF_VARGET,fid,1, temp
NCDF_VARGET,fid,5, alt
NCDF_VARGET,fid,17,lat
NCDF_VARGET,fid,18,lon
NCDF_VARGET,fid,21,lst
NCDF_VARGET,fid,37, UTC
whlat=where(lat(*,9) GE 35 and lat(*,9) LE 45)               ;The middle of the profile at the 9th bin of the 18-bin MIGHTI profile
whlon=where(lon(whlat,9) GE 240 and lon(whlat,9) LE 260)
;print, lst(whlat(whlon),*)

For m=0,17 do begin
  whNaN=where(temp(whlat(whlon),m) LE 130. OR temp(whlat(whlon),m) GE 500.)           ;temperature in lower thermosphere cannot be more than 500 K and lower than 120 K
  temp(whlat(whlon(whNaN)),m) = !VALUES.F_NAN
  alt(whlat(whlon(whNaN)),m) = !VALUES.F_NAN
Endfor

dummy=fltarr(24,18)
dumAlt=fltarr(24,18)

For i=0,23 do begin
  whtime=where(lst(whlat(whlon),9) GT i and lst(whlat(whlon),9) LT i+1, counts)    ;hourly temperature at ~ 100 km
  IF counts NE 0 then begin
    NumProfile(num,i) = counts
    For j=0,17 do begin
      dummy(i,j) = mean(temp(whlat(whlon(whtime)),j),/NAN)
      dumAlt(i,j) = mean(Alt(whlat(whlon(whtime)),j),/NAN)
    Endfor
  Endif
  wh0=where(dummy(i,*) EQ 0.0)
  dummy(i,wh0) = !VALUES.F_NAN
  dumAlt(i,wh0) = !VALUES.F_NAN
Endfor

dumdata(num,*,*) = dummy
height(num,*,*) = dumAlt
    
End
;=============================================================================================================================
;Main Program
dir='C:\Users\TITUS\Documents\Projects\ICON\'
;dir='C:\Users\TITUS\Documents\Projects\ICON\Winter\'
filestr='ICON_L2-3_*_Temperature_*_v04r000.nc'
findfilestr=dir+filestr
files=file_search(findfilestr)

;Numofday = n_elements(files)/2
;data=fltarr(NumofDay,24,18)               ;24 hours and 18 levels of altitude
data=fltarr(n_elements(files),24,18)
alt=fltarr(n_elements(files),24,18)
NumProfile = intarr(n_elements(files),24)

For i=0, n_elements(files)-1 do Call_Procedure,'ReadICON', files(i), i, data,alt, NumProfile

SumTemp = fltarr(24,18)
SumAlt = fltarr(24,18)

For ii=0,23 do begin
  For jj=0,17 do begin
    SumTemp(ii,jj)=mean(data(*,ii,jj),/NaN)
    SumAlt(ii,jj)=mean(alt(*,ii,jj),/NaN)
  Endfor
Endfor

;SumTempInt = fltarr(24,18)

altitude=indgen(18)*3+81            ;must have the same number of levels as the original data
;For ij=0,23 do SumTempInt(ij,*) = interpol(sumTemp(ij,*), sumAlt(ij,*),altitude,/NaN,/spline)
For ij=0,23 do SumTemp(ij,*) = interpol(sumTemp(ij,*), sumAlt(ij,*),altitude,/NaN,/spline)

;Have to run ReadSummerTVintLidar.pro first to retrieve lidar temperature (avgTemp).
;To composite temperature (lidar night and ICON Day)

MonthTemp = fltarr(24,18)           
;altitude=indgen(18)*3+80
lidarTemp=fltarr(9,18)            ;Same number of level as ICON data
For m=0,8 do lidartemp(m,*)=interpol(avgTemp(m,*),height,altitude,/NaN,/spline)
MonthTemp(0:5,*) = lidartemp(3:8,*)         ;midnight (12:00) to 5:00 am for summer months
MonthTemp(21:23,*) = lidarTemp(0:2,*)         ;9:00 pm to 11:00 pm for summer months
MonthTemp(6:20,*) = SumTemp(6:20,*)         ;ICON Daytime data for summer months

For ik=0,17 do begin
  whbad=where(MonthTemp(*,ik) LE 0.0 OR MonthTemp(*,ik) GE 350, countsBAD)
  IF countsBAD NE 0 Then MonthTemp(whbad,ik) = 350.                               ;set upper limit of temperature as 350 K.
Endfor

MonthTempM = fltarr(25,18)
MonthTempM(0:23,*) = MonthTemp
MonthTempM(24,*) = MonthTemp(0,*)

End
