; This program is to read zenith channel running four Rayleigh mirrors
PRO READFILE,file,Temp,TempErr,UT, height, i

parts=strsplit(file,'\',/extract)
parts0=parts(n_elements(parts)-1)
parts1=strsplit(parts0,'_',/extract)
date=strmid(parts1(0),4,5)

openr, u0, file,/GET_LUN
line=''
while (strmid(line,4,8) NE 'analysis') do readf, u0, line
readf, u0, line
dum0=strsplit(strcompress(line),' ',/extract)
NumofHour=fix(dum0(0))
readf, u0, line
dum1=strsplit(strcompress(line),' ',/extract)
hour=float(dum1)

while (strmid(line,1,5) NE 'altit') do readf, u0, line
header=strsplit(strcompress(line),' ',/extract)
Readf,u0,line
NumofAlt=0
While (Not EOF(u0)) Do Begin
    Readf,u0,line
    Numofalt=NumofAlt+1
Endwhile
Point_Lun,u0,0 ;Reset the pointer to the beginning of the file.
while (strmid(line,1,5) NE 'altit') do readf, u0, line
Readf,u0,line

;numofalt=331

data=fltarr(n_elements(header),NumofAlt)                  ;Standard Tint/Vint file has 331 levels of height
readf, u0,data
ALT=data(0,*)
PhoAvg=data(1,*)
;PhoAvgErr=data(n_elements(header)-2,*)
NitAvg=data(2,*)
NigAvgErr=data(n_elements(header)-1,*)

;lidardata=(data(3:n_elements(header)-3,*))
;lidardata=data(3:NumofHour*2+2,*)
lidardata=data(3:NumofHour+2,*)
lidarErr=data(NumofHour+3:NumofHour*2+2,*)
For mm=0,Numofhour-1 do begin
  wh100=where(lidardata(mm,*) eq 100. or lidarErr(mm,*) GT 50.)
  lidardata(mm,wh100)=!VALUES.F_NAN
  lidarErr(mm,wh100)=!VALUES.F_NAN
Endfor

dumdata = fltarr(99)
dumErr = fltarr(99)

For ii=0,Numofhour-1 do begin
  whUT=where(UT eq hour(ii), count)
  If count NE 0 Then begin
    dumdata=interpol(lidardata(ii,*), alt, height)
    Temp(i,whUT,*)=dumdata
    dumErr=interpol(lidarErr(ii,*), alt, height)
    TempErr(i,whUT,*)=dumErr
  Endif
Endfor

For jj=0, 98 do begin
  wh0=where(Temp(i,*,jj) eq 0.0,count0)
  If count0 NE 0 then Begin
    Temp(i,wh0,jj)=!VALUES.F_NAN
    TempErr(i,wh0,jj)=!VALUES.F_NAN
  Endif
Endfor

FREE_LUN, u0

END
;==============================================================================================================================
;Main Program
;dir='D:\C Drive Backup\NaAnalysis\Results_USU\2020_27_SS\Summer\'
;dir='D:\C Drive Backup\NaAnalysis\Results_USU\SummerDay\'
dir='D:\C Drive Backup\NaAnalysis\Results_USU\WinterDay\'
Tfilestr='Tint*_57_*'
Vfilestr='Vint*_57_*'
Tfiles=file_search(dir+Tfilestr)
Vfiles=file_search(dir+Vfilestr)

Temp=fltarr(n_elements(Tfiles),16,99)
TempErr=fltarr(n_elements(Tfiles),16,99)
Vind=fltarr(n_elements(Vfiles),16,99)
VindErr=fltarr(n_elements(Tfiles),16,99)
height=indgen(99)*0.5+70.0

NumHour = 11
;UT=indgen(16)+11.5        ;Summer daytime from UT 11.5 to UT 27.5
UT=indgen(NumHour)+13.5        ;winter daytime from UT 13.5 to UT 23.5

For i=0, n_elements(Tfiles)-1 do call_procedure,'Readfile', Tfiles(i),Temp,TempErr,UT, height, i
For j=0, n_elements(Vfiles)-1 do call_procedure,'Readfile', Vfiles(j),Vind,VindErr,UT, height, j

AvgDayTemp = fltarr(Numhour,99)
AvgDayTempErr = fltarr(Numhour,99)
AvgDayVind = fltarr(Numhour,99)
AvgDayVindErr = fltarr(Numhour,99)

For k=0,Numhour-1 do begin
  For l=0,98 do begin
    AvgDayTemp(k,l) = mean(temp(*,k,l),/NaN)
    AvgDayTempErr(k,l) = mean(tempErr(*,k,l),/NaN)
    AvgDayVind(k,l) = mean(Vind(*,k,l),/NaN)
    AvgDayVindErr(k,l) = mean(VindErr(*,k,l),/NaN)
  Endfor
Endfor

device, decomposed=0
Scrsize=GET_SCREEN_SIZE()
xscrsize = scrsize(0) & yscrsize = scrsize(1)
xwinsize = 0.9*xscrsize
ywinsize = 0.8*yscrsize
;window,/free,xs=xwinsize,ys=ywinsize

loadct,39   ; Sets color table

answerps = ' '
        read,'output plot to screen or postscript (s/e, return =s):',answerps

if answerps eq 'e' then begin ; Encapsulated Postscript
        set_plot, 'ps';,/copy
        device, /landscape,/encapsul, /color,bits_per_pixel=8
        device, xsize = 15.5, ysize = 10, yoffset=16,/INCHES
        device, filename='C:\NaAnalysis\Plot\'+'Winter Daytime Temperature contour'+'.eps'
 endif

Templev0=indgen(80)*2+130
Templev1=indgen(32)*5+130

xr=[11.0,27.0]
yr=[80,115]

contour, AvgDayTemp, UT, height, lev=Templev0,/fill,/cell_fill,yr=yr,ys=1,$
    xr=xr,xs=1, min=150, max=300,title='Summer Temperature Climatology (K)', ytit='altitude (km)', xtit='UT Time (hour)',$
    Charsize=2.8, Charthick=5.8
contour,AvgDayTemp, UT, height, lev=Templev1,/foll,/over,yr=range,ys=1,$
    c_line=[0,2],xr=xr,xs=1,min=150, max=300, c_charsize = 2.8, c_charthick=2.8
     
 End
  