;Fit the composited temperature data (lidar_night+ICON_Day)
FUNCTION MYfunc1, X, A
  RETURN, A[0]+A[1]*sin(2*!pi*x/24.0)+A[2]*cos(2*!pi*x/24.0)$
    +A[3]*sin(2*!pi*x/12.0)+A[4]*cos(2*!pi*x/12.0)$
    +A[5]*sin(2*!pi*x/8.0)+A[6]*cos(2*!pi*x/8.0)
END

;====================================================================================================================================
PRO Tidefit, hour, lidarICON, fitresults, FitErr, REC

      A=[180.0,3.0,3.0,3.0,3.0,3.0,3.0]
      
      For ih=0,17 do begin
;        bad=where(Temp(*,ih) GT 300, nbad, COMPLEMENT=good, NCOMPLEMENT=ngood)
;        IF nbad GT 0 && ngood GT 1 THEN Temp(bad,ih) = INTERPOL(Temp(good,ih), good, bad)

           fit=MPFITFUN('MYfunc1', hour, lidarICON(*,ih), rerr, A, BESTNORM=Norm, DOF=DOF, PERROR=Err)
           
           FitResults(0,ih) = fit[0]           ;mean
           FitResults(1,ih) = sqrt(fit[1]^2+fit[2]^2)  ;diurnal amplitude
           FitResults(2,ih) = sqrt(fit[3]^2+fit[4]^2)  ;semidiurnal amplitude
           FitResults(3,ih) = sqrt(fit[5]^2+fit[6]^2)  ;terdiurnal amplitude
           FitResults(4,ih) = atan(fit[1]/fit[2])*24.0/(2*!pi)  ;diurnal phase
           FitResults(5,ih) = atan(fit[3]/fit[4])*12.0/(2*!pi)  ;semidiurnal phase
           FitResults(6,ih) = atan(fit[5]/fit[6])*8.0/(2*!pi)   ;terdiurnal phase
           
           ScaledErr = Err*sqrt(Norm/DOF)
           
           FitErr(0,ih) = FitErr[0]
           FitErr(1,ih) = (abs(fit[1])*ScaledErr(1)+abs(fit[2])*ScaledErr(2))/sqrt(fit[1]^2+fit[2]^2)
           FitErr(2,ih) = (abs(fit[3])*ScaledErr(3)+abs(fit[4])*ScaledErr(4))/sqrt(fit[3]^2+fit[4]^2)
           FitErr(3,ih) = (abs(fit[5])*ScaledErr(5)+abs(fit[6])*ScaledErr(6))/sqrt(fit[5]^2+fit[6]^2)
;           FitErr(4,ih) = 24.0/(2*!pi)*[cos(fit[1]/fit[2])^2*(abs(fit[1])*ScaledErr(2)/fit[2]^2)*ScaledErr(1)/abs(fit[2])]
           FitErr(4,ih) = 24.0/(2*!pi)*abs((ScaledErr(1)/fit[2]-fit[1]*ScaledErr(2)/fit[2]^2)/(1+(fit[1]/fit[2])^2))
;           FitErr(5,ih) = 12.0/(2*!pi)*[cos(fit[3]/fit[4])^2*(abs(fit[3])*ScaledErr(4)/fit[4]^2)*ScaledErr(3)/abs(fit[4])]
           FitErr(5,ih) = 12.0/(2*!pi)*abs((ScaledErr(3)/fit[4]-fit[3]*ScaledErr(4)/fit[4]^2)/(1+(fit[3]/fit[4])^2))
;           FitErr(6,ih) = 8.0/(2*!pi)*[cos(fit[5]/fit[6])^2*(abs(fit[5])*ScaledErr(6)/fit[6]^2)*ScaledErr(5)/abs(fit[6])]
           FitErr(6,ih) = 8.0/(2*!pi)*abs((ScaledErr(5)/fit[6]-fit[5]*ScaledErr(6)/fit[6]^2)/(1+(fit[5]/fit[6])^2))
           
           REC(*,ih) = Fit[0]+Fit[1]*sin(2*!pi*hour/24.0)+Fit[2]*cos(2*!pi*hour/24.0)$
                +Fit[3]*sin(2*!pi*hour/12.0)+Fit[4]*cos(2*!pi*hour/12.0)$
                +Fit[5]*sin(2*!pi*hour/8.0)+Fit[6]*cos(2*!pi*hour/8.0)
       Endfor


End

;====================================================================================================================================
FitResults = fltarr(7,18)
REC = fltarr(24,18)
FitErr = fltarr(7,18)
time = indgen(24)

tidelev=indgen(10)*3
TempLev0=indgen(54)*5+120.0
TempLev1=indgen(20)*10+100.0
Tstep=20

Call_Procedure,'Tidefit', time,MonthTemp, fitresults, FitErr, REC

RECM = fltarr(25,18)
RECM(0:23,*) = REC
RECM(24,*) = REC(0,*)
timeM = indgen(25)

answerps = ' '
        read,'output plot to screen or postscript (s/e, return =s):',answerps

if answerps eq 'e' then begin ; Encapsulated Postscript
        set_plot, 'ps';,/copy
        device, /landscape,/encapsul, /color,bits_per_pixel=8
        device, xsize = 15.5, ysize = 10, yoffset=16,/INCHES
        device, filename='C:\NaAnalysis\Plot\'+'Summer lidar-ICON Temperature contour'+'.eps'
endif

    device, decomposed=0
    Scrsize=GET_SCREEN_SIZE()
    xscrsize = scrsize(0) & yscrsize = scrsize(1)
    xwinsize = 0.65*xscrsize
    ywinsize = 0.95*yscrsize
;    window,/free,xs=xwinsize,ys=ywinsize, title = 'season'
    !p.multi=[0,1,2]
    !p.thick=2
    !x.thick=2
    !y.thick=2
    loadct,39   ; Sets color table
    
   !P.MULTI = [2,1,2]
    contour,MonthTempM,timeM, altitude, lev=templev0,/fill,/cell_fill,$
        yr=[85,115],xr=[0,24],xs=1, xticks = 6, ys=1., yticks = 6, $
        title='Na lidar-ICON Composite Temperature',$
;        xtitle = 'Local Time (hour)',$
      ytitle='Altitude (km)',charsize=2.5,charthick=5,$
       position = [0.1,0.60,0.9,0.95],/normal ; need specify

    contour,MonthTempM,timeM, altitude, lev=templev1,/foll,/over, c_line=[0,2], c_charsize=2, c_charthick=2

       xleft=0.92
       xright=0.945
       ybot=0.12
       ytop=0.95

       labelstep=Tstep
       ColorBarSmooth,xleft,xright,ybot,ytop,templev0,labelstep,'K'
       
   !P.MULTI = [1,1,2]
    contour,RECM,timeM, altitude, lev=templev0,/fill,/cell_fill,$
       yr=[85,115],xr=[0,24],xs=1, xticks = 6, ys=1., yticks = 6, $
        title='Reconstructed Temperature',$
        xtitle = 'Local Time (hour)',$
      ytitle='Altitude (km)',charsize=2.5,charthick=5,$
       position = [0.1,0.12,0.9,0.47],/normal ; need specify

    contour,RECM,timeM, altitude, lev=templev1,/foll,/over,c_line=[0,2], c_charsize=2, c_charthick=2
      
   if answerps eq 'e' then begin
        device,/close
        set_plot,'win'
        !P.MULTI = 0
   endif

End